// This file is released under the 3-clause BSD license. See COPYING-BSD.
//=================================


// Test flags
//<-- XCOS TEST -->
//<-- NO CHECK ERROR OUTPUT -->

//Load xcos test diagram for rad2deg tests
[macros,path] = libraryinfo('xcos_aerolib');
result = importXcosDiagram(path + "../tests/unit_tests" +"/timezone_conversion.zcos");
assert_checktrue(result);

//This diagram uses 2 variables : 
//  time_out : output calendar time value (from_workspace)
//  time_in : inupt calendar time value (to_workspace)


// ===================================TEST 1
time_in = [2010;12;31;23;52;17];
time_diff = 1;

// Clear variables used for output
clear('time_out');

// Simulate
scicos_simulate(scs_m);

// Define expected values
exp_time = [0; 1; 2];
exp_value = [2011,1,1,0,52,17];

//Validate results
assert_checkequal(exp_time, time_out.time);
assert_checkalmostequal(exp_value, time_out.values(1,:,1));
assert_checkalmostequal(exp_value, time_out.values(2,:,1));
assert_checkalmostequal(exp_value, time_out.values(3,:,1));

// ===================================TEST 2
time_in = [2010;12;31;23;52;17];
time_diff = 0;

// Clear variables used for output
clear('time_out');

// Simulate
scicos_simulate(scs_m);

// Define expected values
exp_time = [0; 1; 2];
exp_value = [2010,12,31,23,52,17];


//Validate results
assert_checkequal(exp_time, time_out.time);
assert_checkalmostequal(exp_value, time_out.values(1,:,1));
assert_checkalmostequal(exp_value, time_out.values(2,:,1));
assert_checkalmostequal(exp_value, time_out.values(3,:,1));


// ===================================TEST 3
time_in = [2010;12;31;23;52;17];
time_diff = -23;

// Clear variables used for output
clear('time_out');

// Simulate
scicos_simulate(scs_m);
exp_value = hypermat([6 1 3]);

// Define expected values
exp_time = [0; 1; 2];
exp_value = [2010,12,31,0,52,17];

//Validate results
assert_checkequal(exp_time, time_out.time);
assert_checkalmostequal(exp_value, time_out.values(1,:,1));
assert_checkalmostequal(exp_value, time_out.values(2,:,1));
assert_checkalmostequal(exp_value, time_out.values(3,:,1));
